Debian Codegraph @

src/apps/sailpoint/identitynow/restapi/mode/searchcount.pm

raw
1 #
2 # Copyright 2024 Centreon (http://www.centreon.com/)
3 #
4 # Centreon is a full-fledged industry-strength solution that meets
5 # the needs in IT infrastructure and application monitoring for
6 # service performance.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License");
9 # you may not use this file except in compliance with the License.
10 # You may obtain a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS,
16 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
17 # See the License for the specific language governing permissions and
18 # limitations under the License.
19 #
20
21 package apps::sailpoint::identitynow::restapi::mode::searchcount;
22
23 use base qw(centreon::plugins::templates::counter);
24
25 use strict;
26 use warnings;
27
28 sub set_counters {
29 my ($self, %options) = @_;
30
31 $self->{maps_counters_type} = [
32 { name => 'global', type => 0 },
33 ];
34
35 $self->{maps_counters}->{global} = [
36 { label => 'results-count', nlabel => 'query.results.count', set => {
37 key_values => [ { name => 'count' } ],
38 closure_custom_output => $self->can('custom_status_output'),
39 perfdatas => [
40 { template => '%s', min => 0 }
41 ]
42 }
43 }
44 ];
45 }
46
47 sub custom_status_output {
48 my ($self, %options) = @_;
49
50 my $msg = $self->{instance_mode}->{option_results}->{output};
51 while ($msg =~ /%\{(.*?)\}/g) {
52 my $key = $1;
53 if (defined($self->{result_values}->{$key})) {
54 $msg =~ s/%\{$key\}/$self->{result_values}->{$key}/g;
55 }
56 }
57
58 return $msg;
59 }
60
61 sub new {
62 my ($class, %options) = @_;
63 my $self = $class->SUPER::new(package => __PACKAGE__, %options, force_new_perfdata => 1);
64 bless $self, $class;
65
66 $options{options}->add_options(arguments => {
67 'query:s' => { name => 'query' },
68 'output:s' => { name => 'output', default => 'Number of results: %{count}' },
69 });
70
71 return $self;
72 }
73
74 sub set_options {
75 my ($self, %options) = @_;
76 }
77
78 sub manage_selection {
79 my ($self, %options) = @_;
80
81 $self->{global}->{count} = $options{custom}->search_count(query => $self->{option_results}->{query});
82 }
83
84 1;
85
86 __END__
87
88 =head1 MODE
89
90 Performs a search with a provided query and returns the
91 count of results.
92
93 More information on 'https://developer.sailpoint.com/idn/api/v3/search-count/'.
94
95 =over 8
96
97 =item B<--query>
98
99 Query parameters used to construct an Elasticsearch query
100 object (see documentation).
101
102 =item B<--output>
103
104 Output to print after retrieving the count of results
105 (default: "Number of results: %{count}").
106
107 =item B<--warning-results-count> B<--critical-results-count>
108
109 Thresholds on count of results.
110
111 =back
112
113 =cut